%global project tempest
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0
# guard for Red Hat OpenStack Platform supported tempest
%global rhosp 1
%global common_desc \
This is a set of integration tests to be run against a live OpenStack cluster.\
Tempest has batteries of tests for OpenStack API validation, Scenarios, and \
other specific tests useful in validating an OpenStack deployment.

%if 0%{?fedora} >= 24
%global with_python3 1
%endif

Name:           openstack-%{project}
Epoch:          1
Version:        18.0.0
Release:        13%{?dist}
Summary:        OpenStack Integration Test Suite (Tempest)
License:        ASL 2.0
Url:            https://launchpad.net/tempest
Source0:        http://tarballs.openstack.org/tempest/tempest-%{upstream_version}-b9f9f892958be615dad47e740e6329c3046b6dbd.tar.gz

# patches_ignore=DROP-IN-RPM
#
Patch0001: 0001-Change-way-how-second-NIC-in-guest-OS-is-configured.patch
Patch0002: 0002-Volume-Service-Testing-default-to-v3-endpoints.patch
Patch0004: 0004-Fix-TypeError-in-_unshelve_server.patch
Patch0005: 0005-Prevent-verify-config-from-IndexError.patch
Patch0006: 0006-Default-enable-run_validation.patch
Patch0007: 0007-Interface-tests-wait-for-server-to-become-SSHable.patch
Patch0008: 0008-interfaces_by_fixed_ip-no-extra-port.patch
Patch0009: 0009-Fix-verify-config-KeyError.patch
Patch0010: 0010-Fix-tempest-cleanup-AttributeError.patch
Patch0011: 0011-Remove-deprecated-services-from-cleanup.patch
Patch0012: 0012-Fix-tempest-cleanup.patch
Patch0013: 0013-Add-unit-tests-for-tempest-cleanup.patch
Patch0014: 0014-Add-NetworkSubnetPools-to-tempest-cleanup.patch
Patch0015: 0015-Log-server-console-output-during-create-get-timestam.patch
Patch0016: 0016-Make-test_hotplug_nic-test-first-check-the-IP.patch
Patch0017: 0017-Improve-ipv6-configuration.patch
Patch0018: 0018-Fix-tempest-cleanup-for-python3.patch
Patch0019: 0019-Fix-cleanup-NotImplemented-error.patch
Patch0020: 0020-Specify-availability-zone-to-create-instances-and-vo.patch
Patch0021: 0021-Specify-AZ-for-non-scenario-tests.patch
Patch0022: 0022-Handle-properly-404-responses-from-Neutron.patch
Patch0023: 0023-tempest-cleanup-should-use-keystone-v3-client.patch
Patch0024: 0024-tempest-cleanup-fix-return-code.patch
Patch0025: 0025-Mark-some-slow-tests-as-slow-so-they-move-out-of-the.patch
Patch0026: 0026-Optimize-test_volume_swap_with_multiattach-for-serve.patch
Patch0027: 0027-Rename-duplicated-class-name-AttachVolumeMultiAttach.patch
Patch0028: 0028-Fix-test_volume_swap_with_multiattach.patch
Patch0029: 0029-Extend-cleanup-CLI-to-delete-regions.patch
Patch0030: 0030-tempest-cleanup-use-admin_mgr-only.patch
Patch0031: 0031-Tempest-cleanup-improve-iterating-over-projects.patch
Patch0032: 0032-Accept-custom-registered-endpoints.patch
Patch0033: 0033-Do-not-pass-device-when-calling-compute.base.attach_.patch
Patch0034: 0034-Fix-test_attach_detach_volume-test-case-to-not-rely-.patch
Patch0035: 0035-Fix-test_stamp_pattern-to-remove-dependency-of-user-.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  python2-oslo-config
BuildRequires:  python2-pbr
BuildRequires:  python2-setuptools
BuildRequires:  python2-devel
BuildRequires:  openstack-macros

Requires:       python-tempest = %{epoch}:%{version}-%{release}

%if 0%{?repo_bootstrap} == 0
Requires:     python2-tempestconf
%endif

%description
%{common_desc}

%package -n    python2-%{project}
Summary:       Tempest Python library

%{?python_provide:%python_provide python2-%{project}}

# Obsoletes python-tempest-lib to avoid breakage
# during upgrade from Newton onwards to till this
# release
Obsoletes:     python-tempest-lib

Requires:      python2-cliff
Requires:      python2-debtcollector
Requires:      python2-fixtures
Requires:      python2-jsonschema
Requires:      python2-netaddr
Requires:      python2-oslo-concurrency >= 3.8.0
Requires:      python2-oslo-config >= 2:4.0.0
Requires:      python2-oslo-log >= 3.22.0
Requires:      python2-oslo-serialization >= 1.10.0
Requires:      python2-oslo-utils >= 3.20.0
Requires:      python2-os-testr >= 0.8.0
Requires:      python2-paramiko
Requires:      python2-pbr
Requires:      python2-prettytable
Requires:      python2-six
Requires:      python2-stevedore
Requires:      python2-stestr
Requires:      python2-testtools
Requires:      python2-urllib3
Requires:      python2-subunit
%if 0%{?fedora} > 0
Requires:      python2-unittest2
Requires:      python2-pyyaml
%else
Requires:      python-unittest2
Requires:      PyYAML
%endif
%description -n python2-%{project}
%{common_desc}

This package contains the tempest python library.

%package -n     python2-%{project}-tests
Summary:        Python Tempest tests
Requires:       python2-tempest = %{epoch}:%{version}-%{release}
%{?python_provide:%python_provide python2-%{project}-tests}

BuildRequires:  python2-mock
BuildRequires:  python2-oslotest
BuildRequires:  python2-subunit
BuildRequires:  python2-oslo-log
BuildRequires:  python2-jsonschema
BuildRequires:  python2-urllib3
BuildRequires:  PyYAML
BuildRequires:  python2-oslo-concurrency
BuildRequires:  python2-paramiko
BuildRequires:  python2-cliff
%if 0%{?fedora} > 0
BuildRequires:  python2-pep8
%else
BuildRequires:  python-pep8
%endif
BuildRequires:  python2-os-testr
BuildRequires:  python2-stestr

Requires:       python2-mock
Requires:       python2-oslotest

%description -n python2-%{project}-tests
%{common_desc}

This package contains tests for the tempest python library.

# Python3 package
%if 0%{?with_python3}
%package -n    python3-%{project}
Summary:       Tempest Python library

%{?python_provide:%python_provide python3-%{project}}
BuildRequires:  python3-oslo-config
BuildRequires:  python3-pbr
BuildRequires:  python3-setuptools
BuildRequires:  python3-devel

Requires:      python3-cliff
Requires:      python3-debtcollector
Requires:      python3-fixtures
Requires:      python3-jsonschema
Requires:      python3-netaddr
Requires:      python3-oslo-concurrency >= 3.8.0
Requires:      python3-oslo-config >= 2:4.0.0
Requires:      python3-oslo-log >= 3.22.0
Requires:      python3-oslo-serialization >= 1.10.0
Requires:      python3-oslo-utils >= 3.20.0
Requires:      python3-os-testr >= 0.8.0
Requires:      python3-paramiko
Requires:      python3-pbr
Requires:      python3-prettytable
Requires:      python3-six
Requires:      python3-stevedore
Requires:      python3-stestr
Requires:      python3-testtools
Requires:      python3-urllib3
Requires:      python3-PyYAML
Requires:      python3-subunit
Requires:      python3-unittest2

%description -n python3-%{project}
%{common_desc}

This package contains the tempest python library.

%package -n     python3-%{project}-tests
Summary:        Python Tempest tests
%{?python_provide:%python_provide python3-%{project}-tests}

Requires:       python3-tempest = %{epoch}:%{version}-%{release}

BuildRequires:  python3-oslotest
BuildRequires:  python3-subunit
BuildRequires:  python3-oslo-log
BuildRequires:  python3-jsonschema
BuildRequires:  python3-urllib3
BuildRequires:  python3-PyYAML
BuildRequires:  python3-oslo-concurrency
BuildRequires:  python3-paramiko
BuildRequires:  python3-cliff
BuildRequires:  python3-pep8
BuildRequires:  python3-os-testr
BuildRequires:  python3-stestr

Requires:       python3-oslotest

%description -n python3-%{project}-tests
%{common_desc}

This package contains tests for the tempest python library.
%endif

%if 0%{?repo_bootstrap} == 0
%package -n    %{name}-all
Summary:       All OpenStack Tempest Plugins

Requires:      %{name} = %{epoch}:%{version}-%{release}

Requires:       python-cinder-tests-tempest
Requires:       python-designate-tests-tempest
Requires:       python-heat-tests-tempest
Requires:       python-horizon-tests-tempest
Requires:       python-ironic-tests-tempest
Requires:       python-keystone-tests-tempest
Requires:       python-mistral-tests-tempest
Requires:       python-neutron-tests-tempest
Requires:       python-sahara-tests-tempest
Requires:       python-zaqar-tests-tempest
Requires:       python-manila-tests-tempest
Requires:       python-telemetry-tests-tempest
Requires:       python-octavia-tests-tempest
Requires:       python-ec2api-tests-tempest
Requires:       python-networking-l2gw-tests-tempest
Requires:       python-patrole-tests-tempest
Requires:       python-tripleo-common-tests-tempest
Requires:       python-novajoin-tests-tempest
Requires:       python-kuryr-tests-tempest
Requires:       python-barbican-tests-tempest

%if 0%{?rhosp} == 0
Requires:       python-congress-tests-tempest
Requires:       python-magnum-tests-tempest
Requires:       python-murano-tests-tempest
Requires:       python-trove-tests-tempest
Requires:       python-vitrage-tests-tempest
Requires:       python-watcher-tests-tempest
%endif

%description -n %{name}-all
%{common_desc}

This package contains all the tempest plugins.
%endif

%if 0%{?with_doc}
%package -n %{name}-doc
Summary:        %{name} documentation

BuildRequires:  python2-sphinx
BuildRequires:  python2-openstackdocstheme

%description -n %{name}-doc
%{common_desc}

It contains the documentation for Tempest.
%endif

%prep
%autosetup -n tempest-%{upstream_version} -S git
# have dependencies being handled by rpms, rather than requirement files
%py_req_cleanup

# remove shebangs and fix permissions
RPMLINT_OFFENDERS="tempest/cmd/list_plugins.py \
tempest/cmd/cleanup.py \
tempest/cmd/cleanup_service.py \
tempest/cmd/verify_tempest_config.py \
tempest/cmd/account_generator.py \
tempest/lib/cmd/skip_tracker.py \
tempest/lib/cmd/check_uuid.py"
sed -i '1{/^#!/d}' $RPMLINT_OFFENDERS
chmod u=rw,go=r $RPMLINT_OFFENDERS

%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif

%if 0%{?with_doc}
# Disable Build the plugin registry step as it uses git to clone
# projects and then generate tempest plugin projects list.
# It is also time taking.
export GENERATE_TEMPEST_PLUGIN_LIST='False'
# TODO(ihrachys): remove when https://review.openstack.org/#/c/523235/ is
# released
sed -i 's/warning-is-error = 1/warning-is-error = 0/' setup.cfg
%{__python2} setup.py build_sphinx -b html
%endif

%install
%py2_install
%if 0%{?with_python3}
%py3_install
%endif

# Generate tempest config
mkdir -p %{buildroot}%{_sysconfdir}/%{project}/
oslo-config-generator --config-file tempest/cmd/config-generator.tempest.conf \
    --output-file %{buildroot}%{_sysconfdir}/%{project}/tempest.conf

mkdir -p %{buildroot}/etc/tempest
mv %{buildroot}/usr/etc/tempest/* %{buildroot}/etc/tempest

%check
export OS_TEST_PATH='./tempest/tests'
export PATH=$PATH:$RPM_BUILD_ROOT/usr/bin
export PYTHONPATH=$PWD
stestr --test-path $OS_TEST_PATH run
%if 0%{?with_python3}
rm -rf .stestr
stestr-3 --test-path $OS_TEST_PATH run
%endif

%files
%license LICENSE
%doc README.rst
%{_bindir}/tempest
%{_bindir}/check-uuid
%{_bindir}/skip-tracker
%{_bindir}/subunit-describe-calls
%{_bindir}/tempest-account-generator
%{_bindir}/verify-tempest-config
%{_sysconfdir}/%{project}/*sample
%{_sysconfdir}/%{project}/*yaml
%config(noreplace) %{_sysconfdir}/%{project}/*.conf

%files -n python2-%{project}
%license LICENSE
%{python2_sitelib}/%{project}
%{python2_sitelib}/%{project}*.egg-info
%exclude %{python2_sitelib}/tempest/tests

%files -n python2-%{project}-tests
%license LICENSE
%{python2_sitelib}/tempest/tests

%if 0%{?with_python3}
%files -n python3-%{project}
%license LICENSE
%{python3_sitelib}/%{project}
%{python3_sitelib}/%{project}*.egg-info
%exclude %{python3_sitelib}/tempest/tests

%files -n python3-%{project}-tests
%license LICENSE
%{python3_sitelib}/tempest/tests
%endif

%if 0%{?repo_bootstrap} == 0
%files -n %{name}-all
%license LICENSE
%endif

%if 0%{?with_doc}
%files -n %{name}-doc
%doc doc/build/html
%license LICENSE
%endif

%changelog
* Wed Feb 05 2020 Martin Kopec <mkopec@redhat.com> 1:18.0.0-13
- Fix test_stamp_pattern to remove dependency of user supplied volume name (rhbz#1797648)
- Fix test_attach_detach_volume test case to not rely on user/libvirt supplied disk name (rhbz#1797648)
- Do not pass device when calling compute.base.attach_volume (rhbz#1797648)

* Fri Jan 31 2020 Martin Kopec <mkopec@redhat.com> 1:18.0.0-12
- Accept custom registered endpoints (rhbz#1730744)
- Tempest cleanup: improve iterating over projects (rhbz#1787464)
- tempest cleanup - use admin_mgr only (rhbz#1755132)
- Extend cleanup CLI to delete regions (rhbz#1763050)

* Mon Oct 21 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-11
- Fix test_volume_swap_with_multiattach (rhbz#1760498)
- Rename duplicated class name AttachVolumeMultiAttachTest (rhbz#1760498)
- Optimize test_volume_swap_with_multiattach for server status wait (rhbz#1760498)
- Mark some slow tests as slow so they move out of the main job (rhbz#1760498)

* Tue Aug 13 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-10
- tempest cleanup fix return code (rhbz#1737754)
- tempest cleanup should use keystone v3 client
- Handle properly 404 responses from Neutron (rhbz#1731173)

* Fri Jun 28 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-9
- Specify AZ for non-scenario tests
- Specify availability zone to create instances and volumes
- Fix cleanup NotImplemented error
- Fix tempest cleanup for python3

* Fri May 31 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-8
- Improve ipv6 configuration
- Make test_hotplug_nic test first check the IP
- Log server console output during create/get timestamp

* Thu Mar 07 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-7
- Add NetworkSubnetPools to tempest cleanup
- Add unit tests for tempest cleanup
- Fix tempest cleanup
- Remove deprecated services from cleanup
- Fix tempest cleanup AttributeError

* Tue Feb 05 2019 Martin Kopec <mkopec@redhat.com> 1:18.0.0-6
- Fix verify-config KeyError

* Tue Nov 27 2018 Artom Lifshitz <alifshit@redhat.com> 1:18.0.0-5
- interfaces_by_fixed_ip no extra port
- Interface tests: wait for server to become SSHable (rhbz#1647954)
- Default enable run_validation
- Prevent verify-config from IndexError
- Fix TypeError in _unshelve_server

* Tue Oct 30 2018 Christian Schwede <cschwede@redhat.com> 1:18.0.0-4
- Volume Service Testing: default to v3 endpoints (rhbz#1643046)

* Mon Sep 03 2018 Slawek Kaplonski <skaplons@redhat.com> 1:18.0.0-3
- Change way how second NIC in guest OS is configured (rhbz#1639616)

* Wed Mar 07 2018 Chandan Kumar <chkumar@redhat.com> 1:18.0.0-2
- Disable repo_bootstrap in order to install python-tempestconf

* Thu Mar 01 2018 RDO <dev@lists.rdoproject.org> 1:18.0.0-1
- Update to 18.0.0

* Wed Feb 21 2018 Alfredo Moralejo <amoralej@redhat.com> 1:17.2.0-5
- Enabled repo_bootstrap until we get all builds ready in queens
- Updated requirements for queens.

* Mon Feb 19 2018 Chandan Kumar <chkumar@redhat.com> 1:17.2.0-4
- Added provides python2-tempest-tests for compatibility with packages which requires it.

* Thu Feb 15 2018 Alfredo Moralejo <amoralej@redhat.com> 1:17.2.0-3
- Added provides python2-tempest for compatibility with packages which requires it.

* Tue Feb 13 2018 Chandan Kumar <chkumar@redhat.com> 1:17.2.0-2
- Added obsoletes for python-tempest-lib removal

* Sat Dec 02 2017 RDO <dev@lists.rdoproject.org> 1:17.2.0-1
- Update to 17.2.0

* Wed Oct 25 2017 Chandan Kumar <chkumar@redhat.com> 1:17.1.0-1
- Update to 17.1.0
- test.py and clients.py as a stable interface

* Thu Aug 31 2017 Chandan Kumar <chkumar@redhat.com> 1:17.0.0-1
- Update to 17.0.0

* Wed Aug 30 2017 Chandan Kumar <chkumar@redhat.com> 1:16.1.0-2-e70e0febgit
- Pin tempest to 16.1.0 (e70e0feb6361d7f97f0b360b25a711a2426775a7) for Pike
- Moves the dynamic and preprovisioned credentials to tempest/lib
- Required for Manila project

* Mon Aug 21 2017 Alfredo Moralejo <amoralej@redhat.com> 1:16.1.0-1
- Update to 16.1.0


